#include <stdio.h>
#include <malloc.h>

int bgmtable[][3]={
	//t@Cʒu@kTCY@𓀃TCY
	{0x000fc, 0x04106, 0x11b4c},
	{0x04108, 0x0cb60, 0x1bbfe},
	{0x0cb62, 0x1205d, 0x1611b},
	{0x1205f, 0x18037, 0x18340},
	{0x18039, 0x21475, 0x23bed},

	{0x21477, 0x28883, 0x15f51},
	{0x28885, 0x3069d, 0x1b62c},
	{0x3069f, 0x39704, 0x1df95},
	{0x39706, 0x3f7cc, 0x1c5b8},
	{0x3f7ce, 0x48f75, 0x21d00},

	{0x48f77, 0x526d2, 0x1fa7b},
	{0x526d4, 0x5ca8c, 0x25fd0},
	{0x5ca8e, 0x64662, 0x1c871},
	{0x64664, 0x6b866, 0x1f118},
	{0x6b868, 0x7213c, 0x17852},

	{0x7213f, 0x7fe9e, 0x3c096},
	{0x7fea0, 0x8a4f4, 0x29e3d},
	{0x8a4f6, 0x9e6cf, 0x527bc},
	{0x9e6d1, 0xa23f4, 0x13a21},
	{0xa23f6, 0xa4a72, 0x0cacd},
};

char bgmfile[][12]={
	"ssg_01.mid",
	"ssg_02.mid",
	"ssg_03.mid",
	"ssg_04.mid",
	"ssg_05.mid",
	"ssg_06.mid",
	"ssg_07.mid",
	"ssg_08.mid",
	"ssg_09.mid",
	"ssg_10.mid",
	"ssg_11.mid",
	"ssg_12.mid",
	"ssg_13.mid",
	"ssg_14.mid",
	"ssg_15.mid",
	"ssg_16.mid",
	"ssg_17.mid",
	"ssg_18.mid",
	"ssg_19.mid",
	"ssg_20.mid",
};
int decode(char *, int, char *, int);
int bit(char **, int *, int);

int main(int argc, char* argv[]){

	int i;
	char *enc, *dec;
	FILE *datf,*bgmf;

	datf=fopen("MUSIC.DAT","rb");
	if(datf==NULL){
		printf("MUSIC.DAT not found.\n");
		return 0;
	}

	enc = (char *)malloc(0x4ADE20 * 2);
	dec = (char *)malloc(0x4ADE20 * 2);
	if(enc == NULL || dec == NULL){
		printf("Can't allocate memory\n");
		return 0;
	}

	for(i=0; i<20; i++){
		printf("Create %s ... \n",bgmfile[i]);

		bgmf = fopen(bgmfile[i],"wb");
		if(bgmf == NULL){
			printf("Can't open file %s\n", bgmfile[i]);
			break;
		}
		fseek(datf,bgmtable[i][0],SEEK_SET);
		fread(enc,1,bgmtable[i][1],datf);

		decode(enc, bgmtable[i][1], dec, bgmtable[i][2]);

		if(fwrite(dec,1,bgmtable[i][2],bgmf) == 0){
			printf("Can't write file %s\n", bgmfile[i]);
			fclose(bgmf);
			break;
		}
		fclose(bgmf);
	}
	free(enc);
	free(dec);
	fclose(datf);
	
	return 0;
}

//ky@
int decode(char *p1, int d1, char *p2, int d2)
{
	char *dic_p = p2 + 0x630041;
	char *e_p   = p2 + d2;
	char buf;

	int adr;
	int cnt = 1;
	int chk = 0x100;
	int i,j;

	while(p2 < e_p){

		if( bit(&p1, &chk, 1) ){

			buf = bit(&p1, &chk, 8);

			*p2++ = buf;
			*(dic_p + cnt) = buf;
			cnt = (cnt + 1) & 0x1fff;
		}
		else {

			adr = bit(&p1, &chk, 13);
			j   = bit(&p1, &chk, 4);

			for(i=0; i<=j+2; i++){
				buf = *(dic_p + adr);
				adr = (adr + 1) & 0x1fff;

				*p2++ = buf;
				*(dic_p + cnt) = buf;
				cnt = (cnt + 1) & 0x1fff;
			}
		}
	}
	return 0;
}

int bit(char **p1, int *chk, int turn)
{
	int i, result=0;

	for(i=0; i<turn; i++){
		result <<=1;

		*chk >>= 1;
		if(*chk == 0x00){
			*chk = 0x80;
			*p1 = *p1 + 1;
		}

		if(**p1 & *chk)
			result |= 0x01;
	}

	return result;
}
